#include "Dict.h"
#include <UnitTest++/UnitTest++.h>

using namespace dictionary;

TEST(Member_empty)
{
    Dict tree;
    CHECK(!tree.member("a"));
}

TEST(Lookup_insert_throws)
{
    Dict tree;
    CHECK_THROW(tree.lookup("a"), Not_found);
}

TEST(Insert_first_element_then_lookup)
{
    Dict tree;
    tree.insert("b", 5);

    CHECK(!tree.member("a"));
    CHECK(tree.member("b"));
    CHECK_EQUAL(5, tree.lookup("b"));
}

TEST(Insert_several)
{
    Dict tree;
    tree.insert("d", 4);
    tree.insert("b", 2);
    tree.insert("a", 1);

    CHECK(tree.member("a"));
    CHECK(tree.member("b"));
    CHECK(!tree.member("c"));
    CHECK(tree.member("d"));
    CHECK(!tree.member("e"));
    CHECK(!tree.member("f"));
    CHECK(!tree.member("g"));

    tree.insert("c", 3);
    tree.insert("f", 6);
    tree.insert("e", 5);
    tree.insert("g", 7);

    CHECK(tree.member("a"));
    CHECK(tree.member("b"));
    CHECK(tree.member("c"));
    CHECK(tree.member("d"));
    CHECK(tree.member("e"));
    CHECK(tree.member("f"));
    CHECK(tree.member("g"));
    CHECK(!tree.member(""));
    CHECK(!tree.member("ax"));
    CHECK(!tree.member("bx"));
    CHECK(!tree.member("cx"));
    CHECK(!tree.member("dx"));
    CHECK(!tree.member("ex"));
    CHECK(!tree.member("fx"));
    CHECK(!tree.member("gx"));

    CHECK_EQUAL(1, tree.lookup("a"));
    CHECK_EQUAL(2, tree.lookup("b"));
    CHECK_EQUAL(3, tree.lookup("c"));
    CHECK_EQUAL(4, tree.lookup("d"));
    CHECK_EQUAL(5, tree.lookup("e"));
    CHECK_EQUAL(6, tree.lookup("f"));
    CHECK_EQUAL(7, tree.lookup("g"));

    CHECK_THROW(tree.lookup("h"), Not_found);
}

